From 7924219cb525293460efba3977538a0ab14c7366 Mon Sep 17 00:00:00 2001
From: Ralph Bean <rbean@redhat.com>
Date: Jul 09 2015 19:27:42 +0000
Subject: [PATCH 184/1001] Make users the owner of their own hub.


---

diff --git a/hubs/models.py b/hubs/models.py
index 99b2cb9..4c6eee2 100644
--- a/hubs/models.py
+++ b/hubs/models.py
@@ -162,6 +162,8 @@ class Hub(BASE):
         session.delete(association)
         session.commit()
 
+    def is_admin(self, user):
+        return user in self.owners
 
     @classmethod
     def by_name(cls, session, name):
@@ -174,8 +176,12 @@ class Hub(BASE):
         hub = cls(name=username, summary=fullname,
                   avatar=username2avatar(username))
         session.add(hub)
+
         hubs.defaults.add_user_widgets(session, hub, username, fullname)
 
+        user = User.by_username(session, username)
+        hub.subscribe(session, user, role='owner')
+
     @property
     def right_width(self):
         return 12 - self.left_width
@@ -296,10 +302,13 @@ class User(BASE):
     @property
     def bookmarks(self):
         # TODO -- someday make this editable/configurable.
-        return sorted(list(set([assoc.hub for assoc in self.associations
-                if assoc.role == 'member'
-                or assoc.role == 'subscriber'
-                or assoc.role == 'owner'])), key=operator.attrgetter('name'))
+        return sorted(list(set([
+            assoc.hub for assoc in self.associations
+            if assoc.role == 'member'
+            or assoc.role == 'subscriber'
+            or assoc.role == 'owner'
+            and assoc.hub.name != self.username
+        ])), key=operator.attrgetter('name'))
 
     @property
     def username(self):

